#include <memory>
#include <ricxfcpp/xapp.hpp>
long m1000_count = 0;    // message counters, one for each type
long m1001_count = 0;

using namespace std;
using namespace xapp;

// callback function that will increase the appropriate counter
void cbf( xapp::Message& mbuf, int mtype, int subid, int len,
            xapp::Msg_component payload,  void* data ) {
    long* counter;
    if( (counter = (long *) data) != NULL ) {
        (*counter)++;
    }
    cout << "[INFO] TEST Callback got a message, type=" << mtype << ", length=" << len << endl;
    cout << "[INFO] Payload is " << (char*)payload.get() << endl;
    cout << *counter << endl;
}

int main( ) {
    std::unique_ptr<Xapp> xapp;
    char* listen_port = (char *) "4560";
    bool  wait4table = false;
    fprintf( stderr, "[INFO] listening on port %s\n", listen_port );
    xapp = std::unique_ptr<Xapp>(
          new Xapp( listen_port, wait4table ) );


    // register the same callback function for both msg types
    xapp->Add_msg_cb( 1000, cbf, (void *) &m1000_count );
    xapp->Add_msg_cb( 1001, cbf, (void *) &m1001_count );
    // run for 1 threads.
    xapp->Run( 1 );        // start the callback driver
}

